#ifndef __BSP_I2C_H
#define __BSP_I2C_H

#include "bsp.h"

//FM175XX Pin_SDA
#define SDA_GPIO					GPIOA
#define SDA_PIN					  GPIO_Pin_15			// SDA
//FM175XX Pin_SCL
#define SCL_GPIO					GPIOA
#define SCL_PIN					  GPIO_Pin_14			// SCL
//FM175XX Pin_NRST
#define PORT_NRST					GPIOA
#define PIN_NRST					GPIO_Pin_11			//PB13 NPD

#define IIC_WR	0		/* дbit */
#define IIC_RD	1		/* bit */

#define DEVICE_EE256	0xa0	//FM24C256ַ
#define DEVICE_17522	0x50	//FM17522Eַ

//IO
#define IIC_SCL_1  GPIO_SetBits(SCL_GPIO,SCL_PIN) 
#define IIC_SCL_0  GPIO_ResetBits(SCL_GPIO,SCL_PIN)
#define IIC_SDA_1  GPIO_SetBits(SDA_GPIO,SDA_PIN) 
#define IIC_SDA_0  GPIO_ResetBits(SDA_GPIO,SDA_PIN) 

//IICв
void bsp_IIC_Init(void);        //ʼIICIO				 
void IIC_Start(void);				//IICʼź
void IIC_Stop(void);	  			//IICֹͣź
void IIC_Send_Byte(u8 txd);			//IICһֽ
u8 IIC_Read_Byte(unsigned char ack);//IICȡһֽ
u8 IIC_Wait_Ack(void); 				//IICȴACKź
void IIC_Ack(void);					//IICACKź
void IIC_NAck(void);				//IICACKź
uint8_t IIC_ReadByte(void);
uint8_t ee_CheckOk(void);
uint8_t ee_ReadBytes (uint16_t _usAddress, uint8_t *_pReadBuf, uint16_t _usSize);
uint8_t ee_WriteBytes(uint8_t *_pWriteBuf, uint16_t _usAddress, uint16_t _usSize);
u8 READ_SDA(void);
u8 READ_SCL(void);
void SDA_OUT(void);
void SDA_IN(void);

uint08 I2C_Send_Bit( uint08 BIT_def ) ;
uint08 I2C_Send_Byte( uint08 x_byte ) ;
uint08 Sendaddr( uint08 Device, uint16 Addr, uint08 AddrLen, uint08 Opt ) ;
uint08 Wait_for_end( uint08 Device );
uint08 I2C_Write_Bottom_Int(uint08 Device, uint16 Addr, uint08 AddrLen, uint08 *Buf, uint08 Len);
uint08 I2C_Read_Bottom_Int(uint08 Device, uint16 Addr, uint08 AddrLen, uint08 *Buf, uint08 Len);
void I2C_Init(void);
u8 READ_SCL(void);
#endif
