/*
*********************************************************************************************************
*
*	ģ : I2Cģ
*	ļ : bsp_i2c_gpio.c
*	     : V1.0
*	˵     : gpioģi2c, FM33GϵCPUģ鲻Ӧò֡I2C߻
*
*
*********************************************************************************************************
*/

#include "bsp.h"

//IICʼ ģIIC
void bsp_IIC_Init(void)
{
	OutputIO( SCL_GPIO, SCL_PIN, 1 );	 //SCL
	OutputIO( SDA_GPIO, SDA_PIN, 1 );	 //SDA

	IIC_SCL_1;	
	IIC_SDA_1;  
}

/*
*********************************************************************************************************
*	  : i2c_Delay
*	˵: I2Cλӳ٣400KHz
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Delay(void)
{
	uint8_t i;

	for (i = 0; i < 10; i++);
}

void SDA_OUT(void)
{
	OutputIO(SDA_GPIO, SDA_PIN, 1 );
}

void SCL_OUT(void)
{
	OutputIO(SCL_GPIO, SCL_PIN, 1 );
}

void SDA_IN(void)
{
	InputtIO(SDA_GPIO, SDA_PIN, 0);
}

void SCL_IN(void)
{
	InputtIO(SCL_GPIO, SCL_PIN, 0);
}

u8 READ_SDA(void)
{
	u8 sda_bit;
	
	sda_bit = GPIO_ReadInputDataBit(SDA_GPIO, SDA_PIN);

	return sda_bit;
}

u8 READ_SCL(void)
{
	u8 scl_bit;
	
	scl_bit = GPIO_ReadInputDataBit(SCL_GPIO, SCL_PIN);

	return scl_bit;
}

//IICʼź
void IIC_Start(void)
{
	SDA_OUT();     //sda
	IIC_SDA_1;	  	  
	IIC_SCL_1;
	i2c_Delay();
 	IIC_SDA_0;//START:when CLK is high,DATA change form high to low 
	i2c_Delay();
	IIC_SCL_0;//ǯסI2Cߣ׼ͻ 
}	 

//IICֹͣź
void IIC_Stop(void)
{
	SDA_OUT();//sda
	IIC_SCL_0;
	IIC_SDA_0;//STOP:when CLK is high DATA change form low to high
 	i2c_Delay();
	IIC_SCL_1; 
	IIC_SDA_1;//I2C߽ź
	i2c_Delay();							   	
}
//ȴӦźŵ
//ֵ1Ӧʧ
//        0Ӧɹ
u8 IIC_Wait_Ack(void)
{
	u8 ucErrTime=0;
	SDA_IN();      //SDAΪ  
	IIC_SDA_1;i2c_Delay();	   
	IIC_SCL_1;i2c_Delay(); 
	while(READ_SDA())
	{
		ucErrTime++;
		if(ucErrTime>20)
		{
			IIC_Stop();
			return 1;
		}
	}
	IIC_SCL_0;//ʱ0 	   
	return 0;  
} 
//ACKӦ
void IIC_Ack(void)
{
	IIC_SCL_0;
	SDA_OUT();
	IIC_SDA_0;
	i2c_Delay();
	IIC_SCL_1;
	i2c_Delay();
	IIC_SCL_0;
}
//ACKӦ		    
void IIC_NAck(void)
{
	IIC_SCL_0;
	SDA_OUT();
	IIC_SDA_1;
	i2c_Delay();
	IIC_SCL_1;
	i2c_Delay();
	IIC_SCL_0;
}					 				     
//IICһֽ
//شӻӦ
//1Ӧ
//0Ӧ			  
void IIC_Send_Byte(u8 txd)
{                        
    u8 t;   
	  SDA_OUT(); 	    
    IIC_SCL_0;//ʱӿʼݴ
    for(t=0;t<8;t++)
    {              
			if((txd&0x80)>>7)
			{
				IIC_SDA_1;
			}
			else
			{
				IIC_SDA_0;
			}
			
      txd<<=1; 
			
		  i2c_Delay();  
		  IIC_SCL_1;
		  i2c_Delay();
		  IIC_SCL_0;	
		  i2c_Delay();
    }	 
} 	    
//1ֽڣack=1ʱACKack=0nACK   
u8 IIC_Read_Byte(unsigned char ack)
{
	unsigned char i,receive=0;
	SDA_IN();//SDAΪ
    for(i=0;i<8;i++ )
	{
    IIC_SCL_0; 
    i2c_Delay();
		IIC_SCL_1;
    receive<<=1;
    if(READ_SDA())receive++;   
		i2c_Delay(); 
    }					 
    if (!ack)
        IIC_NAck();//nACK
    else
        IIC_Ack(); //ACK   
    return receive;
}