/*
*********************************************************************************************************
*
*	ģ : modbusײ
*	ļ : bsp_modbus.c
*	     : V1.0
*	˵     : Modbusṩշĺ
*
*	Copyright (C), 2014-2015,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

static void MODBUS_RxTimeOut(void);
static uint8_t g_rtu_timeout = 0;

MODBUS_T g_tModbus;

extern void MODBUS_AnalyzeApp(void);
/*
*********************************************************************************************************
*	  : MODBUS_InitVar
*	˵: ʼModbusṹ
*	    : _Baud ͨŲʣĲRTUЭĳʱʱ䡣3.5ַ
*			  _WorkMode жϴģʽ1. RXM_NO_CRC   RXM_MODBUS_HOST   RXM_MODBUS_DEVICE
*
*	  ֵ: 
*********************************************************************************************************
*/
void MODBUS_InitVar(uint32_t _Baud, uint8_t _WorkMode)
{
	g_rtu_timeout = 0;
	g_tModbus.RxCount = 0;

	g_tModbus.Baud = _Baud;

	g_tModbus.WorkMode = WKM_NO_CRC;	/* ֡CRCУ */

	bsp_Usart_Init(UART5, _Baud);
}

/*
*********************************************************************************************************
*	  : MODBUS_Poll
*	˵: ݰ. á
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MODBUS_Poll(void)
{
	uint16_t crc1;

	if (g_rtu_timeout == 0)
	{
		/* ûгʱաҪ g_tModbus.RxCount */
		return;
	}

	/* յ
		05 06 00 88 04 57 3B70 (8 ֽ)
			05    :  ĺվ
			06    :  ָ
			00 88 :  ʾĴ
			04 57 :  ,,,ת 10  1111.λǰ,
			3B70  :  ֽ CRC 	05 57У
	*/
	g_rtu_timeout = 0;

	switch (g_tModbus.WorkMode)
	{
		case WKM_NO_CRC:	/* ֡CRCУ. ASCIIЭ */
			{
				/* յݸƵһȴAPPȡ */
				memcpy(g_tModbus.AppRxBuf, g_tModbus.RxBuf, g_tModbus.RxCount);
				g_tModbus.AppRxCount = g_tModbus.RxCount;
////////				bsp_PutMsg(MSG_485_RX, 0);		/* һյ485֡Ϣ */
			}
			break;

		case WKM_MODBUS_HOST:			/* Modbus ģʽ */
			if (g_tModbus.RxCount < 4)
			{
				goto err_ret;
			}

			/* CRCУ */
			crc1 = CRC16_Modbus(g_tModbus.RxBuf, g_tModbus.RxCount);
			if (crc1 != 0)
			{
				goto err_ret;
			}

			/* վַ (1ֽڣ */
			g_tModbus.AppRxAddr = g_tModbus.RxBuf[0];	/* 1ֽ վ */

			/* յݸƵһȴAPPȡ */
			memcpy(g_tModbus.AppRxBuf, g_tModbus.RxBuf, g_tModbus.RxCount);
			g_tModbus.AppRxCount = g_tModbus.RxCount;
////////			bsp_PutMsg(MSG_485_RX, 0);		/* ðFIFOһյ485֡Ϣ */
			break;

		case WKM_MODBUS_DEVICE:			/* Modbus ӻģʽ */
			if (g_tModbus.RxCount < 4)
			{
				goto err_ret;
			}

			/* CRCУ */
			crc1 = CRC16_Modbus(g_tModbus.RxBuf, g_tModbus.RxCount);
			if (crc1 != 0)
			{
				goto err_ret;
			}

			/* վַ (1ֽڣ */
			g_tModbus.AppRxAddr = g_tModbus.RxBuf[0];	/* 1ֽ վ */

			/* ӦòЭ */
			MODBUS_AnalyzeApp();
			break;

		default:
			break;
	}

err_ret:
	g_tModbus.RxCount = 0;	/* ´֡ͬ */
}

/*
*********************************************************************************************************
*	  : MODBUS_ReciveNew
*	˵: ڽжϷñյһֽʱִһα
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MODBUS_ReciveNew(uint8_t _byte)
{
	/*
		3.5ַʱֻRTUģʽ棬ΪRTUģʽûпʼͽ
		ݰֻ֮ܿʱ֣ModbusڲͬĲ£ʱǲһģ
		Ծ3.5ַʱ䣬ʸߣʱСʵͣʱӦʹ

        4800  = 7.297ms
        9600  = 3.646ms
        19200  = 1.771ms
        38400  = 0.885ms
	*/
	uint32_t timeout;

	timeout = 35000000 / g_tModbus.Baud;		/* 㳬ʱʱ䣬λus */

	/* Ӳʱжϣʱus ʱ4Modbus */
	bsp_StartHardTimer(4, timeout, (void *)MODBUS_RxTimeOut);

	if (g_tModbus.RxCount < MODBUS_RX_SIZE)
	{
		g_tModbus.RxBuf[g_tModbus.RxCount++] = _byte;
	}
}

/*
*********************************************************************************************************
*	  : MODBUS_RxTimeOut
*	˵: 3.5ַʱִб ȫֱ g_rtu_timeout = 1; ֪ͨʼ롣
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODBUS_RxTimeOut(void)
{
	g_rtu_timeout = 1;
}

/*
*********************************************************************************************************
*	  : MODBUS_SendWithCRC
*	˵: һ, Զ׷2ֽCRC
*	    : _pBuf ݣ
*			  _ucLen ݳȣCRC
*	  ֵ: 
*********************************************************************************************************
*/
void MODBUS_SendWithCRC(uint8_t *_pBuf, uint8_t _ucLen)
{
	uint16_t crc;
	uint8_t buf[MODBUS_TX_SIZE];

	memcpy(buf, _pBuf, _ucLen);
	crc = CRC16_Modbus(_pBuf, _ucLen);
	buf[_ucLen++] = crc >> 8;
	buf[_ucLen++] = crc;
	RS485_SendBuf(buf, _ucLen);
}

/* Modbus ӦòʾĴ */

/*
*********************************************************************************************************
*	  : MODBUS_01H
*	˵: ȡȦ״̬ӦԶ̿D01/D02/D03
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODBUS_01H(void)
{
}

/*
*********************************************************************************************************
*	  : MODBUS_02H
*	˵: ȡ״̬ӦT01T18
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODBUS_02H(void)
{

}

/*
*********************************************************************************************************
*	  : MODBUS_03H
*	˵: ȡּĴ һּĴȡõǰĶֵ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODBUS_03H(void)
{

}

/*
*********************************************************************************************************
*	  : MODBUS_04H
*	˵: ȡĴӦA01/A02 SMA
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODBUS_04H(void)
{

}

/*
*********************************************************************************************************
*	  : MODBUS_05H
*	˵: ǿƵȦӦD01/D02/D03
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODBUS_05H(void)
{

}

/*
*********************************************************************************************************
*	  : MODBUS_06H
*	˵: дĴ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/

static void MODBUS_06H(void)
{

}


/*
*********************************************************************************************************
*	  : MODBUS_10H
*	˵: дĴ.  ڸдʱ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODBUS_10H(void)
{

}


/*
*********************************************************************************************************
*	  : MODBUS_AnalyzeApp
*	˵: ӦòЭ
*	    :
*		     _DispBuf  洢ʾASCIIַ0
*	  ֵ: 
*********************************************************************************************************
*/
void MODBUS_AnalyzeApp(void)
{
	/* Modbusӻ */
	switch (g_tModbus.RxBuf[1])			/* 2ֽ  */
	{
		case 0x01:	/* ȡȦ״̬ӦԶ̿D01/D02/D03 */
			MODBUS_01H();
			break;

		case 0x02:	/* ȡ״̬ӦT01T18 */
			MODBUS_02H();
			break;

		case 0x03:	/* ȡּĴ һּĴȡõǰĶֵ */
			MODBUS_03H();
			break;

		case 0x04:	/* ȡĴӦA01/A02  */
			MODBUS_04H();
			break;

		case 0x05:	/* ǿƵȦӦD01/D02/D03 */
			MODBUS_05H();
			break;

		case 0x06:	/* дĴ (洢EEPROMеĲ) */
			MODBUS_06H();
			break;

		case 0x10:	/* дĴ дʱӣ */
			MODBUS_10H();
			break;

		default:
			g_tModbus.RspCode = RSP_ERR_CMD;
			//MODBUS_SendAckErr(g_tModbus.RspCode);	/*  */
			break;
	}
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
