#include "bsp.h"

/* 4KbytesΪһSector
16Ϊ1Block */
static uint8_t w25qxx_buf[4096];
/*******************************************************************
*uint8_t w25qxx_init(void)
*w25qxxʼ
*룺none
*none
*أnone
*汾V1.0
********************************************************************/
uint8_t w25qxx_init(void)
{
	bsp_spi_init();
	
	w25qxx_wake_up();
		
	if(w25qxx_read_id() != W25Q16)
	{
		return 1;
	}
	
	w25qxx_power_down();
	
	return 0;
}
///*******************************************************************
//*void w25qxx_disable(void)
//*w25qxx
//*룺none
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************/
void w25qxx_disable(void)
{
		SPI_SSN_Set_High(SPI2);//øSSNź
}
///*******************************************************************
//*void w25qxx_read(uint8_t *cbuf, uint32_t addr, uint16_t csize)  
//*
//*룺cbufַaddrַcsizeȡĳ
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************/
void w25qxx_read(uint8_t *cbuf, uint32_t addr, uint16_t csize)   
{ 
 	uint16_t i;

	SPI_SSN_Set_Low(SPI2);//SSNź		
	
	spi2_send_rw(READ_DATA);
	spi2_send_rw((uint8_t)((addr) >> 16));
	spi2_send_rw((uint8_t)((addr) >> 8));
	spi2_send_rw((uint8_t)addr);
	
    for(i=0; i < csize; i++)
	{ 
        cbuf[i] = spi2_send_rw(0xFF);		
    }
	
	SPI_SSN_Set_High(SPI2);//øSSNź 				    	      
}  
///***************************************************************************
//*void w25qxx_write_page(uint8_t *cbuf, uint32_t addr, uint16_t csize)  
//*һҳд
//*룺cbufַaddrַcsizeȡĳ
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//*****************************************************************************/
void w25qxx_write_page(uint8_t *cbuf, uint32_t addr, uint16_t csize)   
{
	uint16_t i;
	
	w25qxx_write_enable(); 	

	SPI_SSN_Set_Low(SPI2);//SSNź		
	
	spi2_send_rw(PAGE_PROGRAM);
	spi2_send_rw((uint8_t)((addr) >> 16));
	spi2_send_rw((uint8_t)((addr) >> 8));
	spi2_send_rw((uint8_t)addr);
	for(i=0; i < csize; i++)
	{ 
        spi2_send_rw(cbuf[i]);  
    }
	
	SPI_SSN_Set_High(SPI2);//øSSNź
	
	w25qxx_wait_busy();
}
///*******************************************************************************
//*void w25qxx_write_no_check(uint8_t *cbuf, uint32_t addr, uint16_t csize)  
//*д
//*룺cbufַaddrַcsizeȡĳ
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************************/
void w25qxx_write_no_check(uint8_t *cbuf, uint32_t addr, uint16_t csize)   
{ 			 		 
	uint16_t page_remain;	   
	page_remain = 256 - addr % 256;
	
	if(csize <= page_remain)
	{
		page_remain = csize;
	}
	while(1)
	{	   
		w25qxx_write_page(cbuf, addr, page_remain);
		if(csize == page_remain)
		{
			break;
		}
	 	else
		{
			cbuf += page_remain;
			addr += page_remain;	
			csize -= page_remain;			  
			if(csize > 256)
			{
				page_remain = 256;
			} 
			else 
			{
				page_remain = csize;
			} 
		}
	}    
} 
///*******************************************************************************
//*void w25qxx_write(uint8_t *cbuf, uint32_t addr, uint16_t csize)  
//*д
//*룺cbufַaddrַcsizeȡĳ
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************************/
void w25qxx_write(uint8_t *cbuf, uint32_t addr, uint16_t csize)   
{ 
	uint32_t sec_pos;	 /* ַ */
	uint16_t sec_off;	 /* ƫƵַ */
	uint16_t sec_remain; /* ʣַ */	   
 	uint16_t i;    

	/* ַǷ */
	if(addr >= 2 * 1024 * 1024)
	{
		return;
	}
	
	sec_pos = addr / 4096;	        /* ַ */
	sec_off = addr % 4096;          /* ڵƫ */
	sec_remain = 4096 - sec_off;    /* ʣռС */   
	if(csize <= sec_remain)
	{
		sec_remain = csize;
	}
	while(1)
	{
		w25qxx_read(w25qxx_buf, sec_pos * 4096, 4096);/*  */
		
		for(i = 0; i < sec_remain; i++)/* ǷҪ */
		{
			if(w25qxx_buf[sec_off + i] != 0xFF)
			{
				break;
			}
		}

		if(i < sec_remain)/* Ҫ */
		{
			w25qxx_erase_sector(sec_pos);
			for(i = 0; i < sec_remain; i++)/*  */
			{
				w25qxx_buf[i + sec_off] = cbuf[i];
			}
			w25qxx_write_no_check(w25qxx_buf, sec_pos * 4096, 4096);
		}
		else
		{
			w25qxx_write_no_check(cbuf, addr, sec_remain);
		}
		
		if(csize == sec_remain)/* д */
		{
			break;
		}
		else
		{
			sec_pos++;				    /* ַ1 */
			sec_off = 0;			    /* ƫλΪ0 */ 	 
		   	cbuf += sec_remain;  	    /* ָƫ */
			addr += sec_remain;	        /* дַƫ */	   
		   	csize -= sec_remain;	    /* ֽݼ */
			if(csize > 4096)
			{
				sec_remain = 4096;/* һд */
			}
			else 
			{
				sec_remain = csize;/* һд */
			}
		}
	} 
}
/*******************************************************************
*uint16_t w25qxx_read_id(void)
*ȡID
*룺none
*none
*أnone
*ߣ쳤
*汾V1.0
********************************************************************/
uint16_t w25qxx_read_id(void)
{
	uint16_t id = 0;

  SPI_SSN_Set_Low(SPI2);//SSNź
				    
	spi2_send_rw(READ_DEVICE_ID);
	spi2_send_rw(0); 
	spi2_send_rw(0);
	spi2_send_rw(0);	
	id |= spi2_send_rw(0xFF) << 8;
	id |= spi2_send_rw(0xFF);	
	
	SPI_SSN_Set_High(SPI2);//øSSNź
	
	return id;
}
///*******************************************************************
//*uint16_t w25qxx_read_id(void)
//*ȡ״̬Ĵ
//		BIT7  6   5:4   3   2   1   0
//		BPL  AAI  RES  BP1 BP0 WEL BUSY
//*룺none
//*none
//*أ״̬
//*ߣ쳤
//*汾V1.0
//********************************************************************/
uint8_t w25qxx_read_sr(void)   
{  
	uint8_t byte = 0;  

	SPI_SSN_Set_Low(SPI2);//SSNź		
                            
	spi2_send_rw(READ_STATUS_REG);
	byte = spi2_send_rw(0xFF);
	
	SPI_SSN_Set_High(SPI2);//øSSNź  
	
	return byte;   
} 
///*******************************************************************
//*void w25qxx_write_sr(uint8_t sr)
//*д״̬Ĵ
//*룺Ҫдֵ
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************/
void w25qxx_write_sr(uint8_t sr)   
{  
	
	SPI_SSN_Set_Low(SPI2);//SSNź	

	spi2_send_rw(ENABLE_WRITE_STATUS_REG);             
	spi2_send_rw(WRITE_STATUS_REG);
	spi2_send_rw(sr);
	
	SPI_SSN_Set_High(SPI2);//øSSNź  
} 
///*******************************************************************
//*void w25qxx_write_enable(void)  
//*дʹ
//*룺none
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************/
void w25qxx_write_enable(void)   
{  
	SPI_SSN_Set_Low(SPI2);//SSNź		
                            
	spi2_send_rw(WRITE_ENABLE);
	
	SPI_SSN_Set_High(SPI2);//øSSNź
 
} 
///*******************************************************************
//*void w25qxx_write_disable(void)  
//*дֹ
//*룺none
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************/
void w25qxx_write_disable(void)   
{  
	SPI_SSN_Set_Low(SPI2);//SSNź		
                            
	spi2_send_rw(WRITE_DISABLE);
	
	SPI_SSN_Set_High(SPI2);//øSSNź  
} 
///*******************************************************************
//*void w25qxx_wait_busy(void)    
//*ȴ
//*룺none
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************/
void w25qxx_wait_busy(void)   
{   
	while((w25qxx_read_sr() & 0x01) == 0x01);
} 
///*******************************************************************
//*void w25qxx_erase_chip(void) 
//*оƬ
//*룺none
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************/
void w25qxx_erase_chip(void)   
{  
	w25qxx_write_enable(); 
	w25qxx_wait_busy();	
	
	SPI_SSN_Set_Low(SPI2);//SSNź		
                            
	spi2_send_rw(CHIP_ERASE);
	
	SPI_SSN_Set_High(SPI2);//øSSNź  
	w25qxx_wait_busy();
} 
///*******************************************************************
//*void w25qxx_erase_sector(uint32_t addr) 
//*һ
//*룺ַ
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************/
void w25qxx_erase_sector(uint32_t addr)    
{  
	addr *= 4096;
	
	w25qxx_write_enable(); 
	w25qxx_wait_busy();	

	SPI_SSN_Set_Low(SPI2);//SSNź		
                            
	spi2_send_rw(SECTOR_ERASE_4KB);
	spi2_send_rw((uint8_t)((addr) >> 16));
	spi2_send_rw((uint8_t)((addr) >> 8));
	spi2_send_rw((uint8_t)addr);
	
	SPI_SSN_Set_High(SPI2);//øSSNź  
	w25qxx_wait_busy();
}
///*******************************************************************
//*void w25qxx_power_down(void)    
//*ģʽ
//*룺ַ
//*none
//*أnone
//*ߣ쳤
//*汾V1.0
//********************************************************************/
void w25qxx_power_down(void)    
{  
	SPI_SSN_Set_Low(SPI2);//SSNź	
                            
	spi2_send_rw(W25X_POWER_DOWN);

	SPI_SSN_Set_High(SPI2);//øSSNź

	delay_ms(1);//ʱ
}
/*******************************************************************
*void w25qxx_wake_up(void)    
*
*룺ַ
*none
*أnone
*汾V1.0
********************************************************************/
void w25qxx_wake_up(void)    
{  
	SPI_SSN_Set_Low(SPI2);//SSNź
                            
	spi2_send_rw(W25X_WAKE_UP);

	SPI_SSN_Set_High(SPI2);//øSSNź

	delay_ms(1);//ʱ
}
