/*
*********************************************************************************************************
*
*	ģ : MODSBUSͨų 
*	ļ : modbus_host.c
*	     : V1.4
*	˵     : ͨųͨЭMODBUS
*	޸ļ¼ :
*		汾              ˵
*       V1.4   2015-11-28 ޸Э
*
*	Copyright (C), 2015-2016,  www.armfly.com
*
*********************************************************************************************************
*/
#include "bsp.h"

#define TIMEOUT		5000	     /* ʱʱ, λms */
#define NUM			  1		    /* ѭʹ */

/* ÿӻļֵ */

MODH_T g_tModH;
uint8_t g_modh_timeout = 0;

static void MODH_AnalyzeApp(void);

static void MODH_Read_01H(void);
static void MODH_Read_02H(void);
static void MODH_Read_03H(void);
static void MODH_Read_04H(void);
static void MODH_Read_05H(void);
static void MODH_Read_06H(void);
static void MODH_Read_10H(void);

VAR_T g_tVar;

/*
*********************************************************************************************************
*	  : MODH_SendPacket
*	˵: ݰ COM1
*	    : _buf : ݻ
*			  _len : ݳ
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_SendPacket(uint8_t *_buf, uint16_t _len)
{
	RS485_SendBefor();
	RS485_SendBuf(_buf, _len);	
	delay_ms(5);
  RS485_SendOver();
}

/*
*********************************************************************************************************
*	  : MODH_SendAckWithCRC
*	˵: Ӧ,ԶCRC.  
*	    : ޡ g_tModH.TxBuf[], [g_tModH.TxCount
*	  ֵ: 
*********************************************************************************************************
*/
static void MODH_SendAckWithCRC(void)
{
	uint16_t crc;
	
	crc = CRC16_Modbus(g_tModH.TxBuf, g_tModH.TxCount);
	g_tModH.TxBuf[g_tModH.TxCount++] = crc >> 8;
	g_tModH.TxBuf[g_tModH.TxCount++] = crc;	
	MODH_SendPacket(g_tModH.TxBuf, g_tModH.TxCount);
}

/*
*********************************************************************************************************
*	  : MODH_AnalyzeApp
*	˵: ӦòЭ顣Ӧ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODH_AnalyzeApp(void)
{	
	switch (g_tModH.RxBuf[1])			/* 2ֽ  */
	{
		case 0x01:	/* ȡȦ״̬ */
			MODH_Read_01H();
			break;

		case 0x02:	/* ȡ״̬ */
			MODH_Read_02H();
			break;

		case 0x03:	/* ȡּĴ һּĴȡõǰĶֵ */
			MODH_Read_03H();
			break;

		case 0x04:	/* ȡĴ */
			MODH_Read_04H();
			break;

		case 0x05:	/* ǿƵȦ */
			MODH_Read_05H();
			break;

		case 0x06:	/* дĴ */
			MODH_Read_06H();
			break;		

		case 0x10:	/* дĴ */
			MODH_Read_10H();
			break;
		
		default:
			break;
	}
}

/*
*********************************************************************************************************
*	  : MODH_Send01H
*	˵: 01Hָѯ1ּĴ
*	    : _addr : վַ
*			  _reg : Ĵ
*			  _num : Ĵ
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Send01H(uint8_t _addr, uint16_t _reg, uint16_t _num)
{
	g_tModH.TxCount = 0;
	g_tModH.TxBuf[g_tModH.TxCount++] = _addr;		/* վַ */
	g_tModH.TxBuf[g_tModH.TxCount++] = 0x01;		/*  */	
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg;		/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num;		/* Ĵ ֽ */
	
	MODH_SendAckWithCRC();		/* ݣԶCRC */
	g_tModH.fAck01H = 0;		  /* ձ־ */
	g_tModH.RegNum = _num;		/* Ĵ */
	g_tModH.Reg01H = _reg;		/* 03HָеļĴַӦݽз */	
}

/*
*********************************************************************************************************
*	  : MODH_Send02H
*	˵: 02HָɢĴ
*	    : _addr : վַ
*			  _reg : Ĵ
*			  _num : Ĵ
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Send02H(uint8_t _addr, uint16_t _reg, uint16_t _num)
{
	g_tModH.TxCount = 0;
	g_tModH.TxBuf[g_tModH.TxCount++] = _addr;		/* վַ */
	g_tModH.TxBuf[g_tModH.TxCount++] = 0x02;		/*  */	
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg;		/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num;		/* Ĵ ֽ */
	
	MODH_SendAckWithCRC();		/* ݣԶCRC */
	g_tModH.fAck02H = 0;		/* ձ־ */
	g_tModH.RegNum = _num;		/* Ĵ */
	g_tModH.Reg02H = _reg;		/* 03HָеļĴַӦݽз */	
}

/*
*********************************************************************************************************
*	  : MODH_Send03H
*	˵: 03Hָѯ1ּĴ
*	    : _addr : վַ
*			  _reg : Ĵ
*			  _num : Ĵ
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Send03H(uint8_t _addr, uint16_t _reg, uint16_t _num)
{
	g_tModH.TxCount = 0;
	g_tModH.TxBuf[g_tModH.TxCount++] = _addr;		/* վַ */
	g_tModH.TxBuf[g_tModH.TxCount++] = 0x03;		/*  */	
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg;		/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num;		/* Ĵ ֽ */
	
	MODH_SendAckWithCRC();		/* ݣԶCRC */
	g_tModH.fAck03H = 0;		/* ձ־ */
	g_tModH.RegNum = _num;		/* Ĵ */
	g_tModH.Reg03H = _reg;		/* 03HָеļĴַӦݽз */	
}

/*
*********************************************************************************************************
*	  : MODH_Send04H
*	˵: 04HָĴ
*	    : _addr : վַ
*			  _reg : Ĵ
*			  _num : Ĵ
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Send04H(uint8_t _addr, uint16_t _reg, uint16_t _num)
{
	g_tModH.TxCount = 0;
	g_tModH.TxBuf[g_tModH.TxCount++] = _addr;		/* վַ */
	g_tModH.TxBuf[g_tModH.TxCount++] = 0x04;		/*  */	
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg;		/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num;		/* Ĵ ֽ */
	
	MODH_SendAckWithCRC();		/* ݣԶCRC */
	g_tModH.fAck04H = 0;		/* ձ־ */
	g_tModH.RegNum = _num;		/* Ĵ */
	g_tModH.Reg04H = _reg;		/* 03HָеļĴַӦݽз */	
}

/*
*********************************************************************************************************
*	  : MODH_Send05H
*	˵: 05HָдǿõȦ
*	    : _addr : վַ
*			  _reg : Ĵ
*			  _value : Ĵֵ,2ֽ
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Send05H(uint8_t _addr, uint16_t _reg, uint16_t _value)
{
	g_tModH.TxCount = 0;
	g_tModH.TxBuf[g_tModH.TxCount++] = _addr;			/* վַ */
	g_tModH.TxBuf[g_tModH.TxCount++] = 0x05;			/*  */	
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg >> 8;		/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg;			/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _value >> 8;		/* Ĵֵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _value;			/* Ĵֵ ֽ */
	
	MODH_SendAckWithCRC();		/* ݣԶCRC */

	g_tModH.fAck05H = 0;		/* յӻӦ־Ϊ1 */
}

/*
*********************************************************************************************************
*	  : MODH_Send06H
*	˵: 06Hָд1ּĴ
*	    : _addr : վַ
*			  _reg : Ĵ
*			  _value : Ĵֵ,2ֽ
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Send06H(uint8_t _addr, uint16_t _reg, uint16_t _value)
{
	g_tModH.TxCount = 0;
	g_tModH.TxBuf[g_tModH.TxCount++] = _addr;			/* վַ */
	g_tModH.TxBuf[g_tModH.TxCount++] = 0x06;			/*  */	
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg >> 8;		/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg;			/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _value >> 8;		/* Ĵֵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _value;			/* Ĵֵ ֽ */
	
	MODH_SendAckWithCRC();		/* ݣԶCRC */
	
	g_tModH.fAck06H = 0;		/* յӻӦ־Ϊ1 */
}

/*
*********************************************************************************************************
*	  : MODH_Send10H
*	˵: 10HָдּĴ. һ֧23Ĵ
*	    : _addr : վַ
*			  _reg : Ĵ
*			  _num : Ĵn (ÿĴ2ֽ) ֵ
*			  _buf : nĴݡ = 2 * n
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Send10H(uint8_t _addr, uint16_t _reg, uint8_t _num, uint8_t *_buf)
{
	uint16_t i;
	
	g_tModH.TxCount = 0;
	g_tModH.TxBuf[g_tModH.TxCount++] = _addr;		/* վַ */
	g_tModH.TxBuf[g_tModH.TxCount++] = 0x10;		/* վַ */	
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _reg;		/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num >> 8;	/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = _num;		/* Ĵ ֽ */
	g_tModH.TxBuf[g_tModH.TxCount++] = 2 * _num;	/* ֽ */
	
	for (i = 0; i < 2 * _num; i++)
	{
		if (g_tModH.TxCount > H_RX_BUF_SIZE - 3)
		{
			return;		/* ݳȣֱӶ */
		}
		g_tModH.TxBuf[g_tModH.TxCount++] = _buf[i];		/* ݳ */
	}
	
	MODH_SendAckWithCRC();	/* ݣԶCRC */
}

///*
//*********************************************************************************************************
//*	  : MODH_ReciveNew
//*	˵: ڽжϷñյһֽʱִһα
//*	    : 
//*	  ֵ: 1 ʾ
//*********************************************************************************************************
//*/
//void MODH_ReciveNew(uint8_t _data)
//{
//	/*
//		3.5ַʱֻRTUģʽ棬ΪRTUģʽûпʼͽ
//		ݰֻ֮ܿʱ֣ModbusڲͬĲ£ʱǲһģ
//		Ծ3.5ַʱ䣬ʸߣʱСʵͣʱӦʹ

//		4800  = 7.297ms
//		9600  = 3.646ms
//		19200  = 1.771ms
//		38400  = 0.885ms
//	*/
//	uint32_t timeout;

//	g_modh_timeout = 0;
//	
//	timeout = 35000000 / HBAUD485;		/* 㳬ʱʱ䣬λus 35000000*/
//	
////	/* Ӳʱжϣʱus Ӳʱ2MODBUSӻ, ʱ3MODBUSӻ*/
////	bsp_StartHardTimer(3, timeout, (void *)MODH_RxTimeOut);

//	if (g_tModH.RxCount < H_RX_BUF_SIZE)
//	{
//		g_tModH.RxBuf[g_tModH.RxCount++] = _data;
//	}
//}

/*
*********************************************************************************************************
*	  : MODH_RxTimeOut
*	˵: 3.5ַʱִб ȫֱ g_rtu_timeout = 1; ֪ͨʼ롣
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_RxTimeOut(void)
{
	g_modh_timeout = 1;
}

/*
*********************************************************************************************************
*	  : MODH_Poll
*	˵: տָ. 1ms Ӧʱ䡣
*	    : 
*	  ֵ: 0 ʾ 1ʾյȷ
*********************************************************************************************************
*/
void MODH_Poll(void)
{	
	uint16_t crc1;
	if (g_modh_timeout == 0)	/* 3.5ַʱִMODH_RxTimeOut()ȫֱ g_rtu_timeout = 1 */
	{
		/* ûгʱաҪ g_tModH.RxCount */
		return ;
	}	

	g_modh_timeout = 0;
	
	/* յ
		05 06 00 88 04 57 3B70 (8 ֽ)
			05    :  ĺվ
			06    :  ָ
			00 88 :  ʾĴ
			04 57 :  ,,,ת 10  1111.λǰ,
			3B70  :  ֽ CRC 	05 57У
	*/
	if(!popBuff(UART5))
	{
		return;
	}	
	
			 
	if (g_tModH.len < 4)
	{
		printf("\r\nRS485 Data Len Error\r\n");
	}

	/* CRCУ */
	crc1 = CRC16_Modbus(g_tModH.RxBuf, g_tModH.len - 2);
	if(((crc1/256) == g_tModH.RxBuf[g_tModH.len - 2]) &&  ((crc1%256) == g_tModH.RxBuf[g_tModH.len -1]))
	 {
		printf("\r\nStart Deal RS485 Data\r\n"); 
		/* ӦòЭ */
		MODH_AnalyzeApp();
	 }
	 else
	 {
		printf("\r\nRS485 Data CRC Error\r\n");
	 }
	
	g_tModH.RxCount = 0;	/* ´֡ͬ */
}


/*
*********************************************************************************************************
*	  : MODH_Read_01H
*	˵: 01HָӦ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODH_Read_01H(void)
{
	uint8_t bytes;
	uint8_t *p;
	
	if(g_tModH.len > 3)
	{
		bytes = g_tModH.RxBuf[2];	/* ݳ ֽ */				
		switch (g_tModH.Reg01H)
		{
			case REG_D01:
				if(bytes == 8)
				{
					p = &g_tModH.RxBuf[3];	
					
					g_tVar.D01 = BEBufToUint16(p); p += 2;	/* Ĵ */	
					g_tVar.D02 = BEBufToUint16(p); p += 2;	/* Ĵ */	
					g_tVar.D03 = BEBufToUint16(p); p += 2;	/* Ĵ */	
					g_tVar.D04 = BEBufToUint16(p); p += 2;	/* Ĵ */
					
					g_tModH.fAck01H = 1;
				}
				break;
		}
	}
}

/*
*********************************************************************************************************
*	  : MODH_Read_02H
*	˵: 02HָӦ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODH_Read_02H(void)
{
	uint8_t bytes;
	uint8_t *p;
	
	if (g_tModH.RxCount > 0)
	{
		bytes = g_tModH.RxBuf[2];	/* ݳ ֽ */				
		switch (g_tModH.Reg02H)
		{
			case REG_T01:
				if (bytes == 6)
				{
					p = &g_tModH.RxBuf[3];	
					
					g_tVar.T01 = BEBufToUint16(p); p += 2;	/* Ĵ */	
					g_tVar.T02 = BEBufToUint16(p); p += 2;	/* Ĵ */	
					g_tVar.T03 = BEBufToUint16(p); p += 2;	/* Ĵ */	
					
					g_tModH.fAck02H = 1;
				}
				break;
		}
	}
}

/*
*********************************************************************************************************
*	  : MODH_Read_04H
*	˵: 04HָӦ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODH_Read_04H(void)
{
	uint8_t bytes;
	uint8_t *p;
	
	if (g_tModH.RxCount > 0)
	{
		bytes = g_tModH.RxBuf[2];	/* ݳ ֽ */				
		switch (g_tModH.Reg04H)
		{
			case REG_T01:
				if (bytes == 2)
				{
					p = &g_tModH.RxBuf[3];	
					
					g_tVar.A01 = BEBufToUint16(p); p += 2;	/* Ĵ */	
					
					g_tModH.fAck04H = 1;
				}
				break;
		}
	}
}

/*
*********************************************************************************************************
*	  : MODH_Read_05H
*	˵: 05HָӦ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODH_Read_05H(void)
{
	if (g_tModH.RxCount > 0)
	{
		if (g_tModH.RxBuf[0] == SlaveAddr)		
		{
			g_tModH.fAck05H = 1;		/* յӦ */
		}
	};
}

/*
*********************************************************************************************************
*	  : MODH_Read_06H
*	˵: 06HָӦ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODH_Read_06H(void)
{
	if (g_tModH.RxCount > 0)
	{
		if (g_tModH.RxBuf[0] == SlaveAddr)		
		{
			g_tModH.fAck06H = 1;		/* յӦ */
		}
	}
}


/*
*********************************************************************************************************
*	  : MODH_Read_03H
*	˵: 03HָӦ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Read_03H(void)
{
	uint8_t bytes;
	uint8_t *p;
	
	if (g_tModH.RxCount > 0)
	{
		bytes = g_tModH.RxBuf[2];	/* ݳ ֽ */				
		switch (g_tModH.Reg03H)
		{
			case REG_P01:
				if (bytes == 32)
				{
					p = &g_tModH.RxBuf[3];	
					
					g_tVar.P01 = BEBufToUint16(p); p += 2;	/* Ĵ */	
					g_tVar.P02 = BEBufToUint16(p); p += 2;	/* Ĵ */	
		
					g_tModH.fAck03H = 1;
				}
				break;
		}
	}
}

/*
*********************************************************************************************************
*	  : MODH_Read_10H
*	˵: 10HָӦ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Read_10H(void)
{
	/*
		10HָӦ:
			ӻַ                11
			                  10
			Ĵʼַֽ	00
			Ĵʼַֽ    01
			Ĵֽ        00
			Ĵֽ        02
			CRCУֽ           12
			CRCУֽ           98
	*/
	if (g_tModH.RxCount > 0)
	{
		if (g_tModH.RxBuf[0] == SlaveAddr)		
		{
			g_tModH.fAck10H = 1;		/* յӦ */
		}
	}
}

/*
*********************************************************************************************************
*	  : MODH_ReadParam_01H
*	˵: . ͨ01Hָʵ֣֮󣬵ȴӻӦ
*	    : 
*	  ֵ: 1 ʾɹ0 ʾʧܣͨųʱ򱻾ܾ
*********************************************************************************************************
*/
uint8_t MODH_ReadParam_01H(uint16_t _reg, uint16_t _num)
{
	int32_t time1;
	uint8_t i;
	
	for (i = 0; i < NUM; i++)
	{
		MODH_Send01H (SlaveAddr, _reg, _num);		  /*  */
		time1 = bsp_GetRunTime();	/* ¼͵ʱ */
		
		while (1)				/* ȴӦ,ʱյӦbreak  */
		{
			bsp_Idle();

			if (bsp_CheckRunTime(time1) > TIMEOUT)		
			{
				printf("\r\nRS485 TIMEOUT\r\n"); 
				break;		/* ͨųʱ */
			}
			
			if (g_tModH.fAck01H > 0)
			{
				break;		/* յӦ */
			}
		}
		
		if (g_tModH.fAck01H > 0)
		{
			break;			/* ѭNUMΣյbreakѭ */
		}
	}
	
	if (g_tModH.fAck01H == 0)
	{
		return 0;
	}
	else 
	{
		return 1;	/* 01H ɹ */
	}
}

/*
*********************************************************************************************************
*	  : MODH_ReadParam_02H
*	˵: . ͨ02Hָʵ֣֮󣬵ȴӻӦ
*	    : 
*	  ֵ: 1 ʾɹ0 ʾʧܣͨųʱ򱻾ܾ
*********************************************************************************************************
*/
uint8_t MODH_ReadParam_02H(uint16_t _reg, uint16_t _num)
{
	int32_t time1;
	uint8_t i;
	
	for (i = 0; i < NUM; i++)
	{
		MODH_Send02H (SlaveAddr, _reg, _num);
		time1 = bsp_GetRunTime();	/* ¼͵ʱ */
		
		while (1)
		{
			bsp_Idle();

			if (bsp_CheckRunTime(time1) > TIMEOUT)		
			{
				break;		/* ͨųʱ */
			}
			
			if (g_tModH.fAck02H > 0)
			{
				break;
			}
		}
		
		if (g_tModH.fAck02H > 0)
		{
			break;
		}
	}
	
	if (g_tModH.fAck02H == 0)
	{
		return 0;
	}
	else 
	{
		return 1;	/* 02H ɹ */
	}
}
/*
*********************************************************************************************************
*	  : MODH_ReadParam_03H
*	˵: . ͨ03Hָʵ֣֮󣬵ȴӻӦ
*	    : 
*	  ֵ: 1 ʾɹ0 ʾʧܣͨųʱ򱻾ܾ
*********************************************************************************************************
*/
uint8_t MODH_ReadParam_03H(uint16_t _reg, uint16_t _num)
{
	int32_t time1;
	uint8_t i;
	
	for (i = 0; i < NUM; i++)
	{
		MODH_Send03H (SlaveAddr, _reg, _num);
		time1 = bsp_GetRunTime();	/* ¼͵ʱ */
		
		while (1)
		{
			bsp_Idle();

			if (bsp_CheckRunTime(time1) > TIMEOUT)		
			{
				break;		/* ͨųʱ */
			}
			
			if (g_tModH.fAck03H > 0)
			{
				break;
			}
		}
		
		if (g_tModH.fAck03H > 0)
		{
			break;
		}
	}
	
	if (g_tModH.fAck03H == 0)
	{
		return 0;	/* ͨųʱ */
	}
	else 
	{
		return 1;	/* д03Hɹ */
	}
}


/*
*********************************************************************************************************
*	  : MODH_ReadParam_04H
*	˵: . ͨ04Hָʵ֣֮󣬵ȴӻӦ
*	    : 
*	  ֵ: 1 ʾɹ0 ʾʧܣͨųʱ򱻾ܾ
*********************************************************************************************************
*/
uint8_t MODH_ReadParam_04H(uint16_t _reg, uint16_t _num)
{
	int32_t time1;
	uint8_t i;
	
	for (i = 0; i < NUM; i++)
	{
		MODH_Send04H (SlaveAddr, _reg, _num);
		time1 = bsp_GetRunTime();	/* ¼͵ʱ */
		
		while (1)
		{
			bsp_Idle();

			if (bsp_CheckRunTime(time1) > TIMEOUT)		
			{
				break;		/* ͨųʱ */
			}
			
			if (g_tModH.fAck04H > 0)
			{
				break;
			}
		}
		
		if (g_tModH.fAck04H > 0)
		{
			break;
		}
	}
	
	if (g_tModH.fAck04H == 0)
	{
		return 0;	/* ͨųʱ */
	}
	else 
	{
		return 1;	/* 04H ɹ */
	}
}
/*
*********************************************************************************************************
*	  : MODH_WriteParam_05H
*	˵: . ͨ05Hָʵ֣֮󣬵ȴӻӦ
*	    : 
*	  ֵ: 1 ʾɹ0 ʾʧܣͨųʱ򱻾ܾ
*********************************************************************************************************
*/
uint8_t MODH_WriteParam_05H(uint16_t _reg, uint16_t _value)
{
	int32_t time1;
	uint8_t i;

	for (i = 0; i < NUM; i++)
	{
		MODH_Send05H (SlaveAddr, _reg, _value);
		time1 = bsp_GetRunTime();	/* ¼͵ʱ */
		
		while (1)
		{
			bsp_Idle();
			
			/* ʱ TIMEOUTΪ쳣 */
			if (bsp_CheckRunTime(time1) > TIMEOUT)		
			{
				break;	/* ͨųʱ */
			}
			
			if (g_tModH.fAck05H > 0)
			{
				break;
			}
		}
		
		if (g_tModH.fAck05H > 0)
		{
			break;
		}
	}
	
	if (g_tModH.fAck05H == 0)
	{
		return 0;	/* ͨųʱ */
	}
	else
	{
		return 1;	/* 05H дɹ */
	}
}

/*
*********************************************************************************************************
*	  : MODH_WriteParam_06H
*	˵: . ͨ06Hָʵ֣֮󣬵ȴӻӦѭNUMд
*	    : 
*	  ֵ: 1 ʾɹ0 ʾʧܣͨųʱ򱻾ܾ
*********************************************************************************************************
*/
uint8_t MODH_WriteParam_06H(uint16_t _reg, uint16_t _value)
{
	int32_t time1;
	uint8_t i;
	
	for (i = 0; i < NUM; i++)
	{	
		MODH_Send06H (SlaveAddr, _reg, _value);
		time1 = bsp_GetRunTime();	/* ¼͵ʱ */
				
		while (1)
		{
			bsp_Idle();
		
			if (bsp_CheckRunTime(time1) > TIMEOUT)		
			{
				break;
			}
			
			if (g_tModH.fAck06H > 0)
			{
				break;
			}
		}
		
		if (g_tModH.fAck06H > 0)
		{
			break;
		}
	}
	
	if (g_tModH.fAck06H == 0)
	{
		return 0;	/* ͨųʱ */
	}
	else
	{
		return 1;	/* д06Hɹ */
	}
}

/*
*********************************************************************************************************
*	  : MODH_WriteParam_10H
*	˵: . ͨ10Hָʵ֣֮󣬵ȴӻӦѭNUMд
*	    : 
*	  ֵ: 1 ʾɹ0 ʾʧܣͨųʱ򱻾ܾ
*********************************************************************************************************
*/
uint8_t MODH_WriteParam_10H(uint16_t _reg, uint8_t _num, uint8_t *_buf)
{
	int32_t time1;
	uint8_t i;
	
	for (i = 0; i < NUM; i++)
	{	
		MODH_Send10H(SlaveAddr, _reg, _num, _buf);
		time1 = bsp_GetRunTime();	/* ¼͵ʱ */
				
		while (1)
		{
			bsp_Idle();
		
			if (bsp_CheckRunTime(time1) > TIMEOUT)		
			{
				break;
			}
			
			if (g_tModH.fAck10H > 0)
			{
				break;
			}
		}
		
		if (g_tModH.fAck10H > 0)
		{
			break;
		}
	}
	
	if (g_tModH.fAck10H == 0)
	{
		return 0;	/* ͨųʱ */
	}
	else
	{
		return 1;	/* д10Hɹ */
	}
}

