#include "bsp.h"  

//cpuδʱ(ʱ)
void Init_SysTick(void)
{
    SysTick_Config(0x1000000UL);
    SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk |//رж
                    //SysTick_CTRL_TICKINT_Msk |
                    SysTick_CTRL_ENABLE_Msk;
}

//ʱǰSysTick
void TicksDelay(uint32_t ClkNum)
{
    uint32_t last = SysTick->VAL;
    
    if(clkmode != 4)
    {
      ClkNum = ClkNum*clkmode;//ӦͬƵ8Mʱʱ2ms32Mʱʱ0.5ms
    }
    else
    {
      ClkNum = ClkNum*clkmode*36/32;
    }
    if(ClkNum>0xF00000)
    {
        ClkNum = 0xF00000;
    }
    while(((last - SysTick->VAL)&0xFFFFFFUL ) < ClkNum);
}
//msʱ
void TicksDelayMs(uint32_t ms , ConditionHook Hook)
{
    uint32_t ClkNum;
    
    ClkNum = (__SYSTEM_CLOCK/1000) ;
    for(;ms>0;ms--)
    {
        if(Hook!=NULL)
        {
            if(Hook()) return ;
        }
        TicksDelay(ClkNum);
    }
}

void delay_ms(uint32_t ms)
{
	TicksDelayMs(ms , NULL);
}
//usʱ
void TicksDelayUs(uint32_t us)
{
    uint32_t ClkNum;
    
    if(us>100000)//100ms
    {
        us = 100000;
    }
    ClkNum = us*(__SYSTEM_CLOCK/1000000) ;
    TicksDelay(ClkNum);
}

//УĴ
unsigned char CheckSysReg( __IO uint32_t *RegAddr, uint32_t Value )
{
	if( *RegAddr != Value ) 
	{
		*RegAddr = Value;
		return 1;
	}
	else
	{
		return 0;
	}
}

//ѯNVICĴӦжǷ
//1 
//0 ر
unsigned char CheckNvicIrqEn( IRQn_Type IRQn )
{
	if( 0 == ( NVIC->ISER[0U] & ((uint32_t)(1UL << (((uint32_t)(int32_t)IRQn) & 0x1FUL)))) )
		return 0;
	else
		return 1;
}

//IOģ⹦:LCD/ADC
void AnalogIO( GPIOx_Type* GPIOx, uint32_t PinNum )
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructureRun;
	
	GPIO_Get_InitPara(GPIOx, PinNum, &GPIO_InitStructureRun);
	
	if( (GPIO_InitStructureRun.Pin		!= PinNum) ||
		(GPIO_InitStructureRun.PxINEN	!= GPIO_IN_Dis) ||
		(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_En) ||
		(GPIO_InitStructureRun.PxPUEN	!= GPIO_PU_Dis) ||
		(GPIO_InitStructureRun.PxFCR	!= GPIO_FCR_ANA) )
	{
		GPIO_InitStructure.Pin = PinNum;
		GPIO_InitStructure.PxINEN = GPIO_IN_Dis;
		GPIO_InitStructure.PxODEN = GPIO_OD_En;
		GPIO_InitStructure.PxPUEN = GPIO_PU_Dis;
		GPIO_InitStructure.PxFCR = GPIO_FCR_ANA;
		
		GPIO_Init(GPIOx, &GPIO_InitStructure);		
	}	
}

//IO 
//type 0 = ͨ 
//type 1 = 
//#define IN_NORMAL	0
//#define IN_PULLUP	1
void InputtIO( GPIOx_Type* GPIOx, uint32_t PinNum, uint8_t Type )
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructureRun;
	
	GPIO_Get_InitPara(GPIOx, PinNum, &GPIO_InitStructureRun);
		
	if( (GPIO_InitStructureRun.Pin		!= PinNum) ||
		(GPIO_InitStructureRun.PxINEN	!= GPIO_IN_En) ||
		(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_En) ||
		((Type == IN_NORMAL)&&(GPIO_InitStructureRun.PxPUEN != GPIO_PU_Dis)) ||
		((Type == IN_PULLUP)&&(GPIO_InitStructureRun.PxPUEN != GPIO_PU_En)) ||
		(GPIO_InitStructureRun.PxFCR	!= GPIO_FCR_IN) )
	{
		GPIO_InitStructure.Pin = PinNum;	
		GPIO_InitStructure.PxINEN = GPIO_IN_En;
		GPIO_InitStructure.PxODEN = GPIO_OD_En;
		if(Type == IN_NORMAL)		GPIO_InitStructure.PxPUEN = GPIO_PU_Dis;
		else						GPIO_InitStructure.PxPUEN = GPIO_PU_En;	
		GPIO_InitStructure.PxFCR = GPIO_FCR_IN;
		
		GPIO_Init(GPIOx, &GPIO_InitStructure);	
	}
}

//IO 
//type 0 = ͨ 
//type 1 = OD
//#define OUT_PUSHPULL	0
//#define OUT_OPENDRAIN	1
void OutputIO( GPIOx_Type* GPIOx, uint32_t PinNum, uint8_t Type )
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructureRun;
	
	GPIO_Get_InitPara(GPIOx, PinNum, &GPIO_InitStructureRun);
	
	if( (GPIO_InitStructureRun.Pin		!= PinNum) ||
		(GPIO_InitStructureRun.PxINEN	!= GPIO_IN_Dis) ||
		((Type == OUT_PUSHPULL)&&(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_Dis)) ||
		((Type == OUT_OPENDRAIN)&&(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_En)) ||
		(GPIO_InitStructureRun.PxPUEN	!= GPIO_PU_Dis) ||
		(GPIO_InitStructureRun.PxFCR	!= GPIO_FCR_OUT) )
	{
		GPIO_InitStructure.Pin = PinNum;
		GPIO_InitStructure.PxINEN = GPIO_IN_Dis;
		if(Type == OUT_PUSHPULL)	GPIO_InitStructure.PxODEN = GPIO_OD_Dis;
		else						GPIO_InitStructure.PxODEN = GPIO_OD_En;
		GPIO_InitStructure.PxPUEN = GPIO_PU_Dis;
		GPIO_InitStructure.PxFCR = GPIO_FCR_OUT;
		 
		GPIO_Init(GPIOx, &GPIO_InitStructure);		
	}
}
//IO⹦ܿ 
//type 0 = ͨ 
//type 1 = OD (ODܽ⹦֧)
//type 2 = ͨ+ 
//type 3 = OD+
//#define ALTFUN_NORMAL				0
//#define ALTFUN_OPENDRAIN			1
//#define ALTFUN_PULLUP				2
//#define ALTFUN_OPENDRAIN_PULLUP	3
void AltFunIO( GPIOx_Type* GPIOx, uint32_t PinNum, uint8_t Type  )
{																
	GPIO_InitTypeDef  GPIO_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructureRun;
	
	GPIO_Get_InitPara(GPIOx, PinNum, &GPIO_InitStructureRun);
	
	if( (GPIO_InitStructureRun.Pin		!= PinNum) ||
		(GPIO_InitStructureRun.PxINEN	!= GPIO_IN_Dis) ||
		(((Type & 0x01) == 0)&&(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_Dis)) ||
		(((Type & 0x01) != 0)&&(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_En)) ||
		(((Type & 0x02) == 0)&&(GPIO_InitStructureRun.PxPUEN	!= GPIO_PU_Dis)) ||
		(((Type & 0x02) != 0)&&(GPIO_InitStructureRun.PxPUEN	!= GPIO_PU_En)) ||
		(GPIO_InitStructureRun.PxFCR	!= GPIO_FCR_DIG) )
	{
		GPIO_InitStructure.Pin = PinNum;
		GPIO_InitStructure.PxINEN = GPIO_IN_Dis;
		if( (Type & 0x01) == 0 )	GPIO_InitStructure.PxODEN = GPIO_OD_Dis;
		else						GPIO_InitStructure.PxODEN = GPIO_OD_En;
		if( (Type & 0x02) == 0 )	GPIO_InitStructure.PxPUEN = GPIO_PU_Dis;
		else						GPIO_InitStructure.PxPUEN = GPIO_PU_En;	
		GPIO_InitStructure.PxFCR = GPIO_FCR_DIG;
		 
		GPIO_Init(GPIOx, &GPIO_InitStructure);		
	}
}

//IOرգodߣ
//ʹЧʱⲿźŸգҲܵFM385ܽ©磻
//ԽFCRΪ01GPIOODENΪ1α©رʹܣΪ1
//עSWDӿڵPG8,9ıǵý޷
void CloseeIO( GPIOx_Type* GPIOx, uint32_t PinNum )
{
	GPIO_InitTypeDef  GPIO_InitStructureRun;
	
	GPIO_Get_InitPara(GPIOx, PinNum, &GPIO_InitStructureRun);
		
	if((GPIO_InitStructureRun.PxFCR	!= GPIO_FCR_OUT))
	{
		GPIO_SetBits(GPIOx, PinNum);
		OutputIO( GPIOx, PinNum, OUT_OPENDRAIN );
	}
	else
	{
		OutputIO( GPIOx, PinNum, OUT_OPENDRAIN );
		GPIO_SetBits(GPIOx, PinNum);		
	}
}

//IOڳʼ״̬
void Init_Pad_Io(void)
{	
	GPIOx_DO_Write(GPIOA, 0x0000);	//
	GPIOx_DO_Write(GPIOB, 0x0000);	//
	GPIOx_DO_Write(GPIOC, 0x0000);	//
	GPIOx_DO_Write(GPIOD, 0x0000);	//
	GPIOx_DO_Write(GPIOE, 0x0000);	//
	GPIOx_DO_Write(GPIOF, 0x0000);	//
	GPIOx_DO_Write(GPIOG, 0x0000);	//
}

//ر80оƬʹõIO
void Close_None_GPIO_80pin(void)
{
	CloseeIO( GPIOC, GPIO_Pin_0 );
	CloseeIO( GPIOC, GPIO_Pin_1 );

	CloseeIO( GPIOD, GPIO_Pin_8);
	CloseeIO( GPIOD, GPIO_Pin_9 );
	CloseeIO( GPIOD, GPIO_Pin_10 );	
	CloseeIO( GPIOD, GPIO_Pin_11 );	
	CloseeIO( GPIOD, GPIO_Pin_12 );	
	CloseeIO( GPIOD, GPIO_Pin_13 );	
	CloseeIO( GPIOD, GPIO_Pin_14 );	
	CloseeIO( GPIOD, GPIO_Pin_15 );	

	CloseeIO( GPIOE, GPIO_Pin_0 );
	CloseeIO( GPIOE, GPIO_Pin_1 );
	CloseeIO( GPIOE, GPIO_Pin_5 );
	CloseeIO( GPIOE, GPIO_Pin_6 );
	CloseeIO( GPIOE, GPIO_Pin_7 );
	CloseeIO( GPIOE, GPIO_Pin_8 );
	CloseeIO( GPIOE, GPIO_Pin_9 );
	CloseeIO( GPIOE, GPIO_Pin_10 );
	CloseeIO( GPIOE, GPIO_Pin_11 );
	CloseeIO( GPIOE, GPIO_Pin_12 );
	CloseeIO( GPIOE, GPIO_Pin_13 );
	CloseeIO( GPIOE, GPIO_Pin_14 );
	CloseeIO( GPIOE, GPIO_Pin_15 );

	CloseeIO( GPIOF, GPIO_Pin_0 );
	CloseeIO( GPIOF, GPIO_Pin_1 );
	CloseeIO( GPIOF, GPIO_Pin_2 );
	CloseeIO( GPIOF, GPIO_Pin_7 );
	CloseeIO( GPIOF, GPIO_Pin_8 );
	CloseeIO( GPIOF, GPIO_Pin_9 );
	CloseeIO( GPIOF, GPIO_Pin_10 );

	CloseeIO( GPIOG, GPIO_Pin_0 );
	CloseeIO( GPIOG, GPIO_Pin_1 );
	CloseeIO( GPIOG, GPIO_Pin_4 );
	CloseeIO( GPIOG, GPIO_Pin_5 );
	CloseeIO( GPIOG, GPIO_Pin_10 );
	CloseeIO( GPIOG, GPIO_Pin_11 );
	CloseeIO( GPIOG, GPIO_Pin_12 );
	CloseeIO( GPIOG, GPIO_Pin_13 );
	CloseeIO( GPIOG, GPIO_Pin_14 );
	CloseeIO( GPIOG, GPIO_Pin_15 );
}

void Close_AllIOEXTI(void)
{
	CheckSysReg( &GPIO->EXTI0_SEL	, 0xFFFF0000 );
	CheckSysReg( &GPIO->EXTI1_SEL	, 0xFFFF0000 );
	CheckSysReg( &GPIO->EXTI2_SEL	, 0xFFFF0000 );
}

void IO_AnalogFunSet(void)
{
	/* PE4ģ⹦ѡ */
	GPIO_ANASEL_PE4ANS_Set(GPIO_ANASEL_PE4ANS_ACMP2_INP1);

	/* PE3ģ⹦ѡ */
	GPIO_ANASEL_PE3ANS_Set(GPIO_ANASEL_PE3ANS_ACMP2_INN1);

	/* PC15ģ⹦ѡ */
	GPIO_ANASEL_PC15ANS_Set(GPIO_ANASEL_PC15ANS_ACMP2_INP0_ADC_IN6);

	/* PC14ģ⹦ѡ */
	GPIO_ANASEL_PC14ANS_Set(GPIO_ANASEL_PC14ANS_ACMP2_INN0);

	/* PC13ģ⹦ѡ */
	GPIO_ANASEL_PC13ANS_Set(GPIO_ANASEL_PC13ANS_ADC_IN2);

	/* PC12ģ⹦ѡ */
	GPIO_ANASEL_PC12ANS_Set(GPIO_ANASEL_PC12ANS_ADC_IN1);
}

void IO_DFFunSet(void)
{
	GPIO_IODF_SetableEx(IODF_PF3	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PE5	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PE2	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PD3	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PD2	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PD1	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PD0	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PC15	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PC14	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PC13	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PC12	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PB7	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PB6	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PB5	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PB4	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PA11	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PA10	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PA9	, DISABLE);
	GPIO_IODF_SetableEx(IODF_PA8	, DISABLE);
}

void IO_WKENFunSet(void)
{
	GPIO_PINWKEN_SetableEx(PINWKEN_PD6	, DISABLE);
	GPIO_PINWKEN_SetableEx(PINWKEN_PC14	, DISABLE);
	GPIO_PINWKEN_SetableEx(PINWKEN_PE2	, DISABLE);
	GPIO_PINWKEN_SetableEx(PINWKEN_PA13	, DISABLE);
	GPIO_PINWKEN_SetableEx(PINWKEN_PG7	, DISABLE);
	GPIO_PINWKEN_SetableEx(PINWKEN_PC13	, DISABLE);
	GPIO_PINWKEN_SetableEx(PINWKEN_PB0	, DISABLE);
	GPIO_PINWKEN_SetableEx(PINWKEN_PF5	, DISABLE);
}

//ر80оƬʹõȫIO(SWDڳ⣬رպܷ)
void Close_AllIO_GPIO_80pin( void )
{	
	//رIOжϹ
	Close_AllIOEXTI();
	
	//ǿر
	GPIO_HDSEL_PE2HDEN_Setable(DISABLE);
	GPIO_HDSEL_PG6HDEN_Setable(DISABLE);
	
	//FOUTźѡ
	GPIO_FOUTSEL_FOUTSEL_Set(GPIO_FOUTSEL_FOUTSEL_LSCLK);
	
	//ģҺADѡ	
	IO_AnalogFunSet();
	
	//IO˲
	IO_DFFunSet();
	
	//رNWKUP
	IO_WKENFunSet();
	
	CloseeIO( GPIOA, GPIO_Pin_0 );	//PA0; //
	CloseeIO( GPIOA, GPIO_Pin_1 );	//PA1; //
	CloseeIO( GPIOA, GPIO_Pin_2 );	//PA2; //
	CloseeIO( GPIOA, GPIO_Pin_3 );	//PA3; //
	CloseeIO( GPIOA, GPIO_Pin_4 );	//PA4; //
	CloseeIO( GPIOA, GPIO_Pin_5 );	//PA5; //
	CloseeIO( GPIOA, GPIO_Pin_6 );	//PA6; //
	CloseeIO( GPIOA, GPIO_Pin_7 );	//PA7; //
	CloseeIO( GPIOA, GPIO_Pin_8 );	//PA8; //
	CloseeIO( GPIOA, GPIO_Pin_9 );	//PA9; //
	CloseeIO( GPIOA, GPIO_Pin_10 );	//PA10;//
	CloseeIO( GPIOA, GPIO_Pin_11 );	//PA11;//
	CloseeIO( GPIOA, GPIO_Pin_12 );	//PA12;//
	CloseeIO( GPIOA, GPIO_Pin_13 );	//PA13;//
	CloseeIO( GPIOA, GPIO_Pin_14 );	//PA14;//
	CloseeIO( GPIOA, GPIO_Pin_15 );	//PA15;//

	CloseeIO( GPIOB, GPIO_Pin_0 );	//PB0; //
	CloseeIO( GPIOB, GPIO_Pin_1 );	//PB1; //
	CloseeIO( GPIOB, GPIO_Pin_2 );	//PB2; //
	CloseeIO( GPIOB, GPIO_Pin_3 );	//PB3; //
	CloseeIO( GPIOB, GPIO_Pin_4 );	//PB4; //
	CloseeIO( GPIOB, GPIO_Pin_5 );	//PB5; //
	CloseeIO( GPIOB, GPIO_Pin_6 );	//PB6; //
	CloseeIO( GPIOB, GPIO_Pin_7 );	//PB7; //
	CloseeIO( GPIOB, GPIO_Pin_8 );	//PB8; //
	CloseeIO( GPIOB, GPIO_Pin_9 );	//PB9; //
	CloseeIO( GPIOB, GPIO_Pin_10 );	//PB10;//
	CloseeIO( GPIOB, GPIO_Pin_11 );	//PB11;//
	CloseeIO( GPIOB, GPIO_Pin_12 );	//PB12;//
	CloseeIO( GPIOB, GPIO_Pin_13 );	//PB13;//
	CloseeIO( GPIOB, GPIO_Pin_14 );	//PB14;//
	CloseeIO( GPIOB, GPIO_Pin_15 );	//PB15;//
	
	CloseeIO( GPIOC, GPIO_Pin_2 );	//PC2; //
	CloseeIO( GPIOC, GPIO_Pin_3 );	//PC3; //
	CloseeIO( GPIOC, GPIO_Pin_4 );	//PC4; //
	CloseeIO( GPIOC, GPIO_Pin_5 );	//PC5; //
	CloseeIO( GPIOC, GPIO_Pin_6 );	//PC6; //
	CloseeIO( GPIOC, GPIO_Pin_7 );	//PC7; //
	CloseeIO( GPIOC, GPIO_Pin_8 );	//PC8; //
	CloseeIO( GPIOC, GPIO_Pin_9 );	//PC9; //
	CloseeIO( GPIOC, GPIO_Pin_10 );	//PC10;//
	CloseeIO( GPIOC, GPIO_Pin_11 );	//PC11;//
	CloseeIO( GPIOC, GPIO_Pin_12 );	//PC12;//
	CloseeIO( GPIOC, GPIO_Pin_13 );	//PC13;//
	CloseeIO( GPIOC, GPIO_Pin_14 );	//PC14;//
	CloseeIO( GPIOC, GPIO_Pin_15 );	//PC15;//
	
	CloseeIO( GPIOD, GPIO_Pin_0 );	//PD0;//
	CloseeIO( GPIOD, GPIO_Pin_1 );	//PD1;//
	CloseeIO( GPIOD, GPIO_Pin_2 );	//PD2;//
	CloseeIO( GPIOD, GPIO_Pin_3 );	//PD3;//
	CloseeIO( GPIOD, GPIO_Pin_4 );	//PD4;//
	CloseeIO( GPIOD, GPIO_Pin_5 );	//PD5;//
	CloseeIO( GPIOD, GPIO_Pin_6 );	//PD6;//
	CloseeIO( GPIOD, GPIO_Pin_7 );	//PD7;//
	
	CloseeIO( GPIOE, GPIO_Pin_2 );	//PE2;//
	CloseeIO( GPIOE, GPIO_Pin_3 );	//PE3;//
	CloseeIO( GPIOE, GPIO_Pin_4 );	//PE4;//

	CloseeIO( GPIOF, GPIO_Pin_3 );	//PF3; //
	CloseeIO( GPIOF, GPIO_Pin_4 );	//PF4; //
	CloseeIO( GPIOF, GPIO_Pin_5 );	//PF5; //
	CloseeIO( GPIOF, GPIO_Pin_6 );	//PF6; //
	CloseeIO( GPIOF, GPIO_Pin_11 );	//PF11;//
	CloseeIO( GPIOF, GPIO_Pin_12 );	//PF12;//
	CloseeIO( GPIOF, GPIO_Pin_13 );	//PF13;//
	CloseeIO( GPIOF, GPIO_Pin_14 );	//PF14;//
	CloseeIO( GPIOF, GPIO_Pin_15 );	//PF15;//
	
	CloseeIO( GPIOG, GPIO_Pin_2 );	//PG2;//
	CloseeIO( GPIOG, GPIO_Pin_3 );	//PG3;//
	CloseeIO( GPIOG, GPIO_Pin_6 );	//PG6;//
	CloseeIO( GPIOG, GPIO_Pin_7 );	//PG7;//
	//עSWDӿڵPG8,9ıǵý޷
	AltFunIO( GPIOG, GPIO_Pin_8, ALTFUN_NORMAL );	//PG8;//SWDTCK
	AltFunIO( GPIOG, GPIO_Pin_9, ALTFUN_NORMAL );	//PG9;//SWDTDO	
}

//ĬϿ󲿷ʱӣûɰرղҪʱ
//ʱӿرնԹӰ첻
void Init_RCC_PERIPH_clk(void)
{
	//PERCLKCON1
	RCC_PERCLK_SetableEx( DCUCLK, 		ENABLE );		//debug controʱʹܣ
	RCC_PERCLK_SetableEx( EXTI2CLK, 	ENABLE );		//EXTIⲿжϲʱӣIO˲ʱʹ
	RCC_PERCLK_SetableEx( EXTI1CLK, 	ENABLE );		//EXTIⲿжϲʱӣIO˲ʱʹ
	RCC_PERCLK_SetableEx( EXTI0CLK, 	ENABLE );		//EXTIⲿжϲʱӣIO˲ʱʹ
	RCC_PERCLK_SetableEx( PDCCLK, 		ENABLE );		//IOʱӼĴʹ
	RCC_PERCLK_SetableEx( ANACCLK, 		ENABLE );		//ģ·ʱʹ
	RCC_PERCLK_SetableEx( IWDTCLK, 		ENABLE );		//IWDTʱʹ
	RCC_PERCLK_SetableEx( SCUCLK, 		ENABLE );		//system controlʱʹܣ
	RCC_PERCLK_SetableEx( PMUCLK, 		ENABLE );		//Դģʱʹ
	RCC_PERCLK_SetableEx( RTCCLK, 		ENABLE );		//RTCʱʹ
	RCC_PERCLK_SetableEx( LPTFCLK, 		ENABLE );		//LPTIMʱʹ
	RCC_PERCLK_SetableEx( LPTRCLK, 		ENABLE );		//LPTIMʱʹ
				
    //PERCLKCON2 SETTING
	RCC_PERCLK_SetableEx( ADCCLK, 		ENABLE );		//ADCʱʹ
	RCC_PERCLK_SetableEx( WWDTCLK, 		ENABLE );		//WWDTʱʹ
	RCC_PERCLK_SetableEx( RAMBISTCLK, 	DISABLE );		//RAMBISTʱʹܣر
	RCC_PERCLK_SetableEx( FLSEPCLK, 	DISABLE );		//Flashдʱʹܣ͹
	RCC_PERCLK_SetableEx( DMACLK, 		ENABLE );		//DMAʱʹ
	RCC_PERCLK_SetableEx( LCDCLK, 		ENABLE );		//LCDʱʹ
	RCC_PERCLK_SetableEx( AESCLK, 		ENABLE );		//AESʱʹ
	RCC_PERCLK_SetableEx( TRNGCLK, 		ENABLE );		//TRNGʱʹ
	RCC_PERCLK_SetableEx( CRCCLK, 		ENABLE );		//CRCʱʹ

    //PERCLKCON3 SETTING
	RCC_PERCLK_SetableEx( I2CCLK, 		ENABLE );		//I2Cʱʹ
  RCC_PERCLK_SetableEx( LPUFCKEN, ENABLE );		//LPUFCKENʱʹ
	RCC_PERCLK_SetableEx( U7816CLK1, 	ENABLE );		//78161ʱʹ
	RCC_PERCLK_SetableEx( U7816CLK0, 	ENABLE );		//78160ʱʹ
  RCC_PERCLK_SetableEx( LPUARTCKEN, 	ENABLE );		//LPUARTĴʱʹ
	RCC_PERCLK_SetableEx( UARTCOMCLK, 	ENABLE );		//UART0~5Ĵʱʹ
	RCC_PERCLK_SetableEx( UART5CLK, 	ENABLE );		//UART5ʱʹ
	RCC_PERCLK_SetableEx( UART4CLK, 	ENABLE );		//UART4ʱʹ
	RCC_PERCLK_SetableEx( UART3CLK, 	ENABLE );		//UART3ʱʹ
	RCC_PERCLK_SetableEx( UART2CLK, 	ENABLE );		//UART2ʱʹ
	RCC_PERCLK_SetableEx( UART1CLK, 	ENABLE );		//UART1ʱʹ
	RCC_PERCLK_SetableEx( UART0CLK, 	ENABLE );		//UART0ʱʹ
	RCC_PERCLK_SetableEx( HSPICLK, 		ENABLE );		//HSPIʱʹ
	RCC_PERCLK_SetableEx( SPI2CLK, 		ENABLE );		//SPI2ʱʹ
	RCC_PERCLK_SetableEx( SPI1CLK, 		ENABLE );		//SPI1ʱʹ

    //PERCLKCON4 SETTING
	RCC_PERCLK_SetableEx( ET4CLK, 		ENABLE );		//ET4ʱʹ
	RCC_PERCLK_SetableEx( ET3CLK, 		ENABLE );		//ET3ʱʹ
	RCC_PERCLK_SetableEx( ET2CLK, 		ENABLE );		//ET2ʱʹ
	RCC_PERCLK_SetableEx( ET1CLK, 		ENABLE );		//ET1ʱʹ
	RCC_PERCLK_SetableEx( BT2CLK, 		ENABLE );		//BT2ʱʹ
	RCC_PERCLK_SetableEx( BT1CLK, 		ENABLE );		//BT1ʱʹ
}

void Init_PLL(void)
{
	RCC_PLL_InitTypeDef PLL_InitStruct;
    
	PLL_InitStruct.PLLDB = 499;	//pllƵ = PLLDB + 1
	PLL_InitStruct.PLLINSEL = RCC_PLLCON_PLLINSEL_XTLF;	//PLLʱԴѡXTLF
	PLL_InitStruct.PLLOSEL = RCC_PLLCON_PLLOSEL_MUL1;	//Ĭѡ1PLLDB1023ʱʹ2ʵָߵıƵ
	PLL_InitStruct.PLLEN = DISABLE;	//ĬϹرPLL
	
	RCC_PLL_Init(&PLL_InitStruct);
	RCC_PLLCON_PLLEN_Setable(DISABLE);//رPLL
}

//ϵͳʱ
//ʹRCHFʱ,define_all.h SYSCLKdefϵͳʱƵ
void Init_SysClk(void)
{
	RCC_RCHF_InitTypeDef RCHF_InitStruct;
	RCC_SYSCLK_InitTypeDef SYSCLK_InitStruct;
	
	RCHF_InitStruct.FSEL = SYSCLKdef;//define_all.h SYSCLKdefϵͳʱƵ
	RCHF_InitStruct.RCHFEN = ENABLE;//RCHF
	
	RCC_RCHF_Init(&RCHF_InitStruct);
	
	SYSCLK_InitStruct.SYSCLKSEL = RCC_SYSCLKSEL_SYSCLKSEL_RCHF;	//ѡRCHFʱ
	SYSCLK_InitStruct.AHBPRES = RCC_SYSCLKSEL_AHBPRES_DIV1;		//AHBƵ
	SYSCLK_InitStruct.APBPRES = RCC_SYSCLKSEL_APBPRES_DIV1;		//APBƵ
	SYSCLK_InitStruct.EXTICKSEL = RCC_SYSCLKSEL_EXTICKSEL_AHBCLK;	//EXTI,˲ʱʹAHBʱ
	SYSCLK_InitStruct.SLP_ENEXTI = ENABLE;//ģʽʹⲿжϲ
	SYSCLK_InitStruct.LPM_RCLP_OFF = DISABLE;//ģʽ¿RCLP	
	
	RCC_SysClk_Init(&SYSCLK_InitStruct);
}

//Mode:0 ģʽпŹжʱ
//Mode:1 ģʽرտŹжʱ
void SCU_Init(uint08 Mode)
{
	if(Mode == 1)//debug
	{
		SCU_MCUDBGCR_DBG_WWDT_STOP_Setable(ENABLE);//ģʽ¹رWWDT
		SCU_MCUDBGCR_DBG_IWDT_STOP_Setable(ENABLE);//ģʽ¹رIWDT
	}
	else//release
	{
		SCU_MCUDBGCR_DBG_WWDT_STOP_Setable(DISABLE);//ģʽWWDT
		SCU_MCUDBGCR_DBG_IWDT_STOP_Setable(DISABLE);//ģʽIWDT
	}
	
	SCU_MCUDBGCR_DBG_ET4_STOP_Setable(DISABLE);//ģʽET4
	SCU_MCUDBGCR_DBG_ET3_STOP_Setable(DISABLE);//ģʽET3
	SCU_MCUDBGCR_DBG_ET2_STOP_Setable(DISABLE);//ģʽET2
	SCU_MCUDBGCR_DBG_ET1_STOP_Setable(DISABLE);//ģʽET1
	SCU_MCUDBGCR_DBG_BT2_STOP_Setable(DISABLE);//ģʽBT2
	SCU_MCUDBGCR_DBG_BT1_STOP_Setable(DISABLE);//ģʽBT1
}

void Init_SysClk_Gen( void )				//ʱѡ
{	
	
	/*ϵͳʱӳ24MҪwait1*/
	if( RCHFCLKCFG > 24 ) 
          FLASH_FLSRDCON_WAIT_Set(FLASH_FLSRDCON_WAIT_1CYCLE);
	else 
          FLASH_FLSRDCON_WAIT_Set(FLASH_FLSRDCON_WAIT_0CYCLE);	
	
	/*PLL*/
	Init_PLL();	//ĬϹرPLL
	
	/*ϵͳʱ*/
	Init_SysClk();	//ĬʹRCHFʱ
	
	/*ʱʹ*/	
	Init_RCC_PERIPH_clk();	//ĬϿ󲿷ʱ
	
	/*DMARAMȼ*/
	RCC_MPRIL_MPRIL_Set(RCC_MPRIL_MPRIL_DMA);	//ĬAHB MasterȼDMA
	
	/*µ縴λ*/
	//pdrborµ縴λҪһ
	//Դѹµ縴λѹʱоƬᱻλס		
	//pdrѹλ׼ǹļͣ޷
	//borѹλ׼ȷҪ2uA
	ANAC_PDRCON_PDREN_Setable(ENABLE);		//PDR
	ANAC_BORCON_OFF_BOR_Setable(ENABLE);	        //رBOR
	
	/*ƼĴ*/
	#ifdef __DEBUG
	SCU_Init(1);//ʱжʱ,رտŹ
	#else
	SCU_Init(0);
	#endif
}

void IWDT_Init(void)
{
	RCC_PERCLK_SetableEx(IWDTCLK, ENABLE);		//IWDTʱʹ
	IWDT_Clr();					//IWDT
	IWDT_IWDTCFG_IWDTOVP_Set(IWDT_IWDTCFG_IWDTOVP_8s);//IWDT
	IWDT_IWDTCFG_IWDTSLP4096S_Setable(ENABLE);	//ʱǷ4096s
}

void RCHF_Adj_EtimxCfg(ETIMx_Type* ETIMx)
{
	ETIM_InitTypeDef init_para;
	volatile uint08 EtimNum;

	EtimNum = ((uint32_t)ETIMx - ETIMER1_BASE)>>5;
	
	//źԴ
	init_para.sig_src_para.SIG1SEL = ETIMx_ETxINSEL_SIG1SEL_GROUP1;		/* ڲź1ԴѡGROUP1 */
	init_para.sig_src_para.SIG2SEL = ETIMx_ETxINSEL_SIG2SEL_GROUP2;		/* ڲź2ԴѡGROUP2 */
	
	switch(EtimNum)
	{
		case 0:	//ETIM1
			//źԴ
			init_para.sig_src_para.GRP1SEL = ETIMx_ETxINSEL_GRP1SEL_ET1_APBCLK;		/* GROUP1 źѡAPBCLK */
			init_para.sig_src_para.GRP2SEL = ETIMx_ETxINSEL_GRP2SEL_ET1_XTLF;		/* GROUP2 źѡXTLF */			
			//ET1ʱʹ	
			RCC_PERCLK_SetableEx( ET1CLK, ENABLE );		
			//NVICж
			NVIC_DisableIRQ(ETIM1_IRQn);	
			break;

		case 1:	//ETIM2
			//źԴ
			init_para.sig_src_para.GRP1SEL = ETIMx_ETxINSEL_GRP1SEL_ET2_APBCLK;		/* GROUP1 źѡAPBCLK */
			init_para.sig_src_para.GRP2SEL = ETIMx_ETxINSEL_GRP2SEL_ET2_XTLF;		/* GROUP2 źѡXTLF */		
			//ET2ʱʹ	
			RCC_PERCLK_SetableEx( ET2CLK, ENABLE );	
			//NVICж
			NVIC_DisableIRQ(ETIM2_IRQn);			
			break;

		case 2:	//ETIM3
			//źԴ
			init_para.sig_src_para.GRP1SEL = ETIMx_ETxINSEL_GRP1SEL_ET3_APBCLK;		/* GROUP1 źѡAPBCLK */
			init_para.sig_src_para.GRP2SEL = ETIMx_ETxINSEL_GRP2SEL_ET3_XTLF;		/* GROUP2 źѡXTLF */		
			//ET3ʱʹ
			RCC_PERCLK_SetableEx( ET3CLK, ENABLE );	
			//NVICж
			NVIC_DisableIRQ(ETIM3_IRQn);		
			break;

		case 3:	//ETIM4
			//źԴ
			init_para.sig_src_para.GRP1SEL = ETIMx_ETxINSEL_GRP1SEL_ET4_APBCLK;		/* GROUP1 źѡAPBCLK */
			init_para.sig_src_para.GRP2SEL = ETIMx_ETxINSEL_GRP2SEL_ET4_XTLF;		/* GROUP2 źѡXTLF */		
			//ET4ʱʹ
			RCC_PERCLK_SetableEx( ET4CLK, ENABLE );		
			//NVICж
			NVIC_DisableIRQ(ETIM4_IRQn);
			break;
		
		default:
			break;
	}
	init_para.sig_src_para.PRESCALE1 = 0;    		//1Ƶ		/* ETxԤƵĴ1 */ 00ʾ1ƵFFʾ256Ƶ
	init_para.sig_src_para.PRESCALE2 = 127;    		//128Ƶ		/* ETxԤƵĴ2 */ 00ʾ1ƵFFʾ256Ƶ
	
	//
	init_para.ctrl_para.EXFLT = ENABLE;								/* ˲ʹܴ */
	init_para.ctrl_para.MOD = ETIMx_ETxCR_MOD_CAPTURE;				/* ģʽѡ׽ģʽ */
	init_para.ctrl_para.CASEN = DISABLE;							/* չʱر */
	init_para.ctrl_para.EDGESEL = ETIMx_ETxCR_EDGESEL_RISING;		/* ģʽطʽѡ񣨼ʱѡmcu_clkʱλЧǲmcu_clkʱؼ */

	init_para.ctrl_para.PWM = DISABLE;								/* PWMر */

	init_para.ctrl_para.CAPMOD = ETIMx_ETxCR_CAPMOD_PERIOD;			/* ׽ģʽ */
	init_para.ctrl_para.CAPCLR = ENABLE;							/* 㲶׽ģʽ *///ʹܺ0׽һЧ֮timerſʼ֮Ĳ׽㣬ֻйرնʱٴ
	init_para.ctrl_para.CAPONCE = ENABLE;							/* β׽ */
	init_para.ctrl_para.CAPEDGE = ETIMx_ETxCR_CAPEDGE_RISING;		/* ׽ѡ */

	init_para.ctrl_para.CMPIE = DISABLE;		/* չʱȽжʹ */
	init_para.ctrl_para.CAPIE = DISABLE;		/* չʱ׽жʹ */
	init_para.ctrl_para.OVIE = DISABLE;			/* չʱжʹ */

	init_para.ctrl_para.INITVALUE = 0; 		//ֵ;		/* ETxֵĴ */
	init_para.ctrl_para.CMP = 0;			/* ETxȽϼĴ */
	
	init_para.ctrl_para.CEN = DISABLE;		/*  */
	
	//ʼETIM
	ETIMx_Init(ETIMx, &init_para);
}

//xtlf32768HzʱΪοԴ
//APBƵ
//ClkMode 1 = 8M
//ClkMode 2 = 16M
//ClkMode 3 = 24M
//ClkMode 4 = 32M
void RCHF_Adj_Proc(ETIMx_Type* ETIMx, uint08 ClkMode )
{
	volatile uint16 Temp16;
	unsigned char n,m,tempbyte,TrimBuf;	
	float DIVclkmode = 1.0;
	
	//FDETO	ͣģ
	//1XTLFδͣ
	//0XTLFͣ
	if( RESET == ANAC_FDETIF_FDETO_Chk())//xtlfͣ
	{
		//ʹòԲ		
		RCC_Init_RCHF_Trim(ClkMode);
		return;
	}
	
	RCHF_Adj_EtimxCfg(ETIMx);

	switch(ClkMode)
	{
		case 1://8
			ETIMx_ETxPESCALE1_Write(ETIMx, 0);//Դ1Ƶ
			DIVclkmode		= 1.0;
			break;
		
		case 2://16/2
			ETIMx_ETxPESCALE1_Write(ETIMx, 1);//Դ2Ƶ
			DIVclkmode		= 1.0;
			break;
		
		case 3://24/4
			ETIMx_ETxPESCALE1_Write(ETIMx, 3);//Դ4Ƶ
			DIVclkmode		= 8.0/6.0;
			break;
		
		case 4://36/4
			ETIMx_ETxPESCALE1_Write(ETIMx, 3);//Դ4Ƶ
			DIVclkmode		= 8.0/9.0;
			break;
		
		default://8
			ETIMx_ETxPESCALE1_Write(ETIMx, 0);//ԴƵ
			DIVclkmode		= 1.0;
			break;	
	}	
		
	for( m=0; m<6; m++ )
	{			
		ETIMx_ETxCR_CEN_Setable(ETIMx, ENABLE);	//ʱ
		
		for( n=0; n<2; n++ ) //жҪ3.906ms = 128/32768 s
		{		
			Temp16 = 0;
			Do_DelayStart();
			{
				if( SET == ETIMx_ETxIF_CAPIF_Chk(ETIMx) ) {Temp16 = 1; break;}//ȴ׽жϱ־
			}While_DelayMsEnd(7.5*clkmode);		//7.5ms
			ETIMx_ETxIF_CAPIF_Clr(ETIMx);		//׽жϱ־
		}	
		ETIMx_ETxCR_CEN_Setable(ETIMx, DISABLE);	//رնʱ
		if( Temp16 == 0 ) continue;
			
		Temp16 = ETIMx_ETxIVR_Read(ETIMx);		//ȡ׽ֵ
			
		if( (Temp16>(31250-120)/DIVclkmode)&&(Temp16<(31250+120)/DIVclkmode) ) //return;//ֱֵӷ
		{
			break;
		}
		else
		{
			TrimBuf = RCC_RCHFTRIM_Read();	//ȡRCHFУ׼ֵ
			if( Temp16 > 31250/DIVclkmode )	//31250 = 8M*128/32768; 156.25 = (15625*2/4*2M)*40k
			{
				Temp16 -= 31250/DIVclkmode;
				tempbyte = (float)Temp16/(156.25/DIVclkmode)+0.5;
				
				if( tempbyte > 0x20 ) tempbyte = 0x20;
				
				if( TrimBuf >= tempbyte )
				{
					RCC_RCHFTRIM_Write(TrimBuf - tempbyte);//RCHFУ׼ֵ
				}
				else
				{
					RCC_RCHFTRIM_Write(0x00);//RCHFУ׼ֵ
				}			
			}
			else
			{
				Temp16 = 31250/DIVclkmode-Temp16;
				tempbyte = (float)Temp16/(156.25/DIVclkmode)+0.5;
				
				if( tempbyte > 0x20 ) tempbyte = 0x20;
				
				if( (TrimBuf + tempbyte) <= 0x7F)
				{
					RCC_RCHFTRIM_Write(TrimBuf + tempbyte);//RCHFУ׼ֵ
				}
				else
				{
					RCC_RCHFTRIM_Write(0x7F);//RCHFУ׼ֵ
				}
			}
			
			if( m == 5 )				//δҵֵ,2εֵȡƽ
			{
				TrimBuf += RCC_RCHFTRIM_Read();
				RCC_RCHFTRIM_Write(TrimBuf/2.0+0.5);				
			}
		}
	}
}

void Init_System(void)
{		
    /*ϵͳ*/
    __disable_irq();		//رȫжʹ
    IWDT_Init();		//ϵͳŹ
    IWDT_Clr();  		//ϵͳŹ	
    Init_SysTick();		//cpuδʱ(ʱ)	
    TicksDelayMs( 10, NULL );	//ʱ,ϵͳϵҪ̽ʱлΪRCHF8MҲҪ̽߷ܵ޷س

    Init_SysClk_Gen();		//ϵͳʱ
    RCC_Init_RCHF_Trim(clkmode);//RCHFУ׼ֵ(оƬλԶ8MУ׼ֵ)ֻǵУRCHF¾

    /*ʼ*/
    Init_Pad_Io();		//IOĴʼ״̬

    Close_None_GPIO_80pin();    //ر80оƬֵ֧IO
    Close_AllIO_GPIO_80pin();   //رȫIO

    /*RTCֵĴ*/
    RTC_ADJUST_Write(0);//RTCʱ¶Ȳֵд0粻ĴֵһRTCʱӿܻƫǳ

    /*׼ѭ*/
    TicksDelayMs( 100, NULL );	//ʱ

    __enable_irq();				//ȫжʹ
}
